Name:       faultd
Version:    0.0.1
Release:    0
License:    Apache-2.0
Source0:    %{name}-%{version}.tar.xz
Source1001: %{name}.manifest
Summary:    Fault detection daemon
Group:      System/Monitoring

%define with_faultd_glib_support 0
%define database_module sqlite_dbadapter

BuildRequires: pkgconfig(libsystemd)
BuildRequires: pkgconfig(json-c)
BuildRequires: pkgconfig(cmocka)
BuildRequires: pkgconfig(sqlite3)
%if %{with_faultd_glib_support}
BuildRequires: pkgconfig(glib-2.0)
%endif

%description
faultd monitors system services, detects their abnormal execution and
helps recover from errors.

%package extra
Summary:    faultd extra modules
Group:      System/Monitoring
BuildRequires: pkgconfig(audit)

%description extra
Set of modules allowing to extend faultd functionality

%package test-services
Summary:    faultd test services
Group:      System/Monitoring

%description test-services
Services used to test faultd functionality

%prep
%setup -q
cp %{SOURCE1001} .

%build
%autogen
%configure \
	--enable-test-services \
%if %{with_faultd_glib_support}
	--enable-glib-mainloop \
%endif
	--enable-unit-tests \
	--enable-forced-reboot

make %{?_smp_mflags}

make check

%install
%make_install

mkdir -p %{buildroot}/%{_unitdir}/basic.target.wants
ln -s ../faultd.service %{buildroot}/%{_unitdir}/basic.target.wants

ln -s %{_sbindir}/faultd %{buildroot}/%{_sbindir}/faultctl

%define moduledir %{_libdir}/faultd/available-modules/
%define moduleconfdir %{_sysconfdir}/faultd/available-modules/
%define enabled_moduledir %{_sysconfdir}/faultd/enabled-modules/

for mod in systemd_listener \
	vip_fault_eh \
	system_reboot_action
do
	ln -s %{moduledir}/${mod}.so %{buildroot}/%{moduleconfdir}/${mod}.so;
	ln -s ../available-modules/${mod}.so %{buildroot}/%{enabled_moduledir}/${mod}.so;
	echo %{moduledir}/${mod}.so >> faultd-files;
	echo %{moduleconfdir}/${mod}.so >> faultd-files;
	echo %{enabled_moduledir}/${mod}.so >> faultd-files;
done

for mod in audit_listener \
	resource_violation_eh \
	service_recover_action \
	service_restart_action \
	standard_fault_eh \
	standard_reboot_eh \
	startup_listener \
	system_reboot_to_recovery_action
do
	ln -s %{moduledir}/${mod}.so %{buildroot}/%{moduleconfdir}/${mod}.so;
	ln -s ../available-modules/${mod}.so %{buildroot}/%{enabled_moduledir}/${mod}.so;
	echo %{moduledir}/${mod}.so >> faultd-extra-files;
	echo %{moduleconfdir}/${mod}.so >> faultd-extra-files;
	echo %{enabled_moduledir}/${mod}.so >> faultd-extra-files;
done

for mod in \
	sqlite_dbadapter
do
	ln -s %{moduledir}/${mod}.so %{buildroot}/%{moduleconfdir}/${mod}.so;
	echo %{moduledir}/${mod}.so >> faultd-extra-files;
	echo %{moduleconfdir}/${mod}.so >> faultd-extra-files;
done

ln -s ../available-modules/%{database_module}.so %{buildroot}/%{enabled_moduledir}/%{database_module}.so;
echo %{enabled_moduledir}/%{database_module}.so >> faultd-extra-files;

%files -f faultd-files
%license COPYING
%manifest %{name}.manifest
%{_localstatedir}/db/faultd
%{_sbindir}/faultd
%{_sbindir}/faultctl
%{_prefix}/lib/faultd/faultd.conf
%{_prefix}/lib/faultd/service.conf.d/dbus.service.conf.d/50-default.conf
%{_prefix}/lib/faultd/service.conf.d/display-manager.service.conf.d/50-default.conf
%{_unitdir}/faultd.service
%{_unitdir}/basic.target.wants/faultd.service
%{_prefix}/lib/systemd/system-generators/vip-generator

%files extra -f faultd-extra-files
%{_prefix}/lib/faultd/modules.conf.d/standard_fault_eh.conf.d/50-default.conf
%{_prefix}/lib/faultd/modules.conf.d/standard_reboot_eh.conf.d/50-default.conf

%files test-services
%{_bindir}/faultd/leaker
%attr(755, root, root) %{_bindir}/faultd/fail-only-once.sh
%attr(755, root, root) %{_bindir}/faultd/fail-always.sh
%{_unitdir}/faultd-failed-service-always-failed.service
%{_unitdir}/faultd-failed-service-single-restart.service
%{_unitdir}/faultd-failed-service-with-recovery.service
%{_unitdir}/faultd-failed-vip-service.service
%{_unitdir}/faultd-recovery-service.service
%{_unitdir}/faultd-res-leak.service
%{_prefix}/lib/faultd/service.conf.d/faultd-failed-service-with-recovery.service.conf.d/50-default.conf
%{_prefix}/lib/faultd/service.conf.d/faultd-failed-vip-service.service.conf.d/50-default.conf

%docs_package
