/*
 * This file is part of faultd.
 *
 * Copyright © 2017 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef FAULTD_JSON_CONFIG_H
#define FAULTD_JSON_CONFIG_H

#include <json-c/json.h>

#include "service.h"

enum config_type {
	CONFIG_TYPE_FILE,
	CONFIG_TYPE_DIR
};

int load_config(const char *src, int type, int optional, struct json_object *c);
int get_config_field(struct json_object *root, const char *key, void *value, int type);

#endif /* FAULTD_JSON_CONFIG_H */
